Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 541)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 542)
@@ -28,9 +28,9 @@
 import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.HashSet;
-import java.util.Iterator;
 import java.util.List;
 
+import org.apache.commons.lang.StringUtils;
 import org.eclipse.core.runtime.CoreException;
 import org.eclipse.core.runtime.IConfigurationElement;
 import org.eclipse.core.runtime.IProgressMonitor;
@@ -111,7 +111,6 @@
 import org.txm.concordance.rcp.messages.Messages;
 import org.txm.concordance.rcp.widgets.ComplexSortSelector;
 import org.txm.cooccurrence.rcp.messages.CooccurrenceUIMessages;
-import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.core.results.TXMResult;
 import org.txm.functions.internal.InternalView;
@@ -136,7 +135,6 @@
 import org.txm.rcp.views.corpora.CorporaView;
 import org.txm.searchengine.cqp.CQPEngine;
 import org.txm.searchengine.cqp.ReferencePattern;
-import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
@@ -167,37 +165,8 @@
 	ComplexSortSelector complexsorter;
 	org.eclipse.swt.widgets.Text cqlSeparator;
 
-	/** The available view keyword properties. */
-	private List<Property> availableKeywordViewProperties;
-	/** The available view left properties. */
-	private List<Property> availableLeftViewProperties;
-	/** The available view right properties. */
-	private List<Property> availableRightViewProperties;
-
-	/** The selected left view properties. */
-	private List<Property> selectedLeftViewProperties;
-	/** The selected right view properties. */
-	private List<Property> selectedRightViewProperties;
-	/** The selected keyword view properties. */
-	private List<Property> selectedKeywordViewProperties;
-
-	/** The available sort properties. */
-	private List<Property> availableKeywordSortProperties;
-	/** The selected keyword sort property. */
-	private List<Property> selectedKeywordSortProperties;
-	/** The selected left sort property. */
-	private List<Property> selectedLeftSortProperties;
-	/** The selected right sort property. */
-	private List<Property> selectedRightSortProperties;
-
-	/** The reference pattern. */
-	private ReferencePattern refViewPattern;
-	private ReferencePattern refSortPattern;
-
-	/** The concordance. */
 	private Concordance concordance;
 
-
 	/** The standard comparator class name. */
 	private LineComparator[] standardComparatorClassName = {
 			new NullComparator(), new LexicographicKeywordComparator(),
@@ -205,27 +174,24 @@
 			new LexicographicRightContextComparator(),
 			new PropertiesReferenceComparator() };
 
-	/** The corpus. */
-	private Corpus corpus;
+	//	/** The n line per page. */
+	//	private int concordance.getNLinePerPage();
+	//
+	//	/** The top line. */
+	//	private int topLine;
+	//
+	//	/** The bottom line. */
+	//	private int bottomLine;
 
-	/** The n line per page. */
-	private int nLinePerPage;
-
-	/** The top line. */
-	private int topLine;
-
-	/** The bottom line. */
-	private int bottomLine;
-
 	/** The current comparator. */
 	protected LineComparator currentComparator;
 
-	/** The left context size. */
-	private int leftContextSize;
+	//	/** The left context size. */
+	//	private int leftContextSize;
+	//
+	//	/** The right context size. */
+	//	private int rightContextSize;
 
-	/** The right context size. */
-	private int rightContextSize;
-
 	/** The mouseposition. */
 	private Point mouseposition;
 
@@ -309,7 +275,7 @@
 	private ArrayList<Property> availableRightSortProperties;
 
 	private Sash sash;
-	
+
 	HashSet<ConcordanceEditorExtension> extensions = new HashSet<ConcordanceEditorExtension>();
 
 	private Listener tableResizeListener;
@@ -327,14 +293,6 @@
 	public void doSaveAs() { }
 
 	/* (non-Javadoc)
-	 * @see org.eclipse.ui.part.EditorPart#isDirty()
-	 */
-	@Override
-	public boolean isDirty() {
-		return false;
-	}
-
-	/* (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#isSaveAsAllowed()
 	 */
 	@Override
@@ -358,15 +316,15 @@
 			throws PartInitException {
 		setSite(site);
 		setInput(input);
-		
+
 		initializeEditor();
-		
+
 		// fetch extensions
 		IConfigurationElement[] config = Platform.getExtensionRegistry()
 				.getConfigurationElementsFor(ConcordanceEditorExtension.EXTENSION_ID);
 		Log.warning("Installing ConcordanceEditorExtension...");
 		Log.warning(Arrays.toString(config));
-		
+
 		for (IConfigurationElement e : config) {
 			try {
 				Log.warning(" "+e.getName()+" from "+e.getContributor().getName());
@@ -403,45 +361,14 @@
 			throw new PartInitException("Cannot open ConcordanceEditor with "+result);
 		}
 		this.concordance = (Concordance)result;
-		this.corpus = concordance.getCorpus();
 
 		this.standardComparators = new ArrayList<LineComparator>();
 		this.userDefinedComparators = new ArrayList<LineComparator>();
 		new ArrayList<LineComparator>();
 		setStandardComparators();
-		this.nLinePerPage = TXMPreferences.getInt(ConcordancePreferences.N_LINE_PER_PAGE, ConcordancePreferences.PREFERENCES_NODE);
-		try {
-			this.availableKeywordViewProperties = new ArrayList<Property>(
-					corpus.getOrderedProperties());
-			this.availableLeftViewProperties = new ArrayList<Property>(corpus
-					.getOrderedProperties());
-			this.availableRightViewProperties = new ArrayList<Property>(corpus
-					.getOrderedProperties());
-			this.availableLeftSortProperties = new ArrayList<Property>(corpus
-					.getOrderedProperties());
-			this.availableKeywordSortProperties = new ArrayList<Property>(corpus
-					.getOrderedProperties());
-			this.availableRightSortProperties = new ArrayList<Property>(corpus
-					.getOrderedProperties());
-		} catch (CqiClientException e) {
-			//System.err.println(Messages.CorporaView_3+" : "+Log.toString(e)); //$NON-NLS-1$
-			try {
-				System.out.println(Messages.ConcordancesEditor_0+CQPEngine.getCqiClient().getLastCQPError());
-				Log.severe(Messages.ConcordancesEditor_0+CQPEngine.getCqiClient().getLastCQPError());
-			} catch (Exception e1) {
-				org.txm.rcp.utils.Logger.printStackTrace(e1);
-				Log.severe("Error while computing concordance: "+e.getLocalizedMessage());
-			} 
+		concordance.setNLinePerPage(TXMPreferences.getInt(ConcordancePreferences.N_LINE_PER_PAGE, ConcordancePreferences.PREFERENCES_NODE));
 
-			return;
-		}
-
-		initializeFields();
-
-		if (concordance != null)
-			setPartName(concordance.getName());
-		else
-			setPartName(corpus.getName());
+		setPartName(concordance.getName());
 	}
 
 	/* (non-Javadoc)
@@ -450,10 +377,6 @@
 	@Override
 	public void createPartControl(Composite parent) {
 		super.createPartControl(parent); // create the top toolbar, display area and bottom toolbar
-		
-//		this.parent = parent;
-//
-//		parent.setLayout(new FormLayout());
 
 		Composite controlArea = getCommandParametersGroup();
 
@@ -465,10 +388,8 @@
 			if (complexsorter != null) {
 				complexsorter.setComparators(this);
 			}
-			
-			fillDisplayArea(topLine, bottomLine); // init columns and show first results if any
-			resetColumnWidths();
-			
+
+			fillDisplayArea();
 		} catch(Exception e) {
 			System.out.println("Error while building interface: "+e.getLocalizedMessage());
 			Log.printStackTrace(e);
@@ -476,7 +397,7 @@
 	}
 
 	private void composeExtraAreas(Composite controlArea, Composite displayArea) {
-		
+
 		for (final ConcordanceEditorExtension ext : extensions) {
 			ISafeRunnable runnable = new ISafeRunnable() {
 				@Override
@@ -509,16 +430,16 @@
 		viewer2.setLabelProvider(new LineLabelProvider(this) {
 			@Override
 			public String getColumnText(Object element, int columnIndex) {
-					Line line = (Line) element;
-					return line.getViewRef().toString();
+				Line line = (Line) element;
+				return line.getViewRef().toString();
 			}
 		});
 		viewer2.setContentProvider(new ConcordancesProvider());
 		viewer2.getTable().setLinesVisible(true);
 		viewer2.getTable().setHeaderVisible(true);
 
-//		firstColumn = new TableColumn(viewer2.getTable(), SWT.LEFT);
-//		firstColumn.setWidth(10);
+		//		firstColumn = new TableColumn(viewer2.getTable(), SWT.LEFT);
+		//		firstColumn.setWidth(10);
 
 		referenceColumn = new TableColumn(viewer2.getTable(), SWT.LEFT);
 		refreshReferenceColumnTitle();
@@ -538,7 +459,7 @@
 				} else {
 					viewer2.getTable().setSortDirection(SWT.UP);
 				}
-				comparator.initialize(corpus);
+				comparator.initialize(concordance.getCorpus());
 				currentComparator = comparator;
 				complexsorter.setKey(4);//set ref key
 				sort();
@@ -550,14 +471,14 @@
 			}
 		});
 		referenceColumn.setWidth(100);
-				
+
 		sash = new Sash(displayArea, SWT.VERTICAL);
 		sash.addSelectionListener(new SelectionAdapter() {
-		      public void widgetSelected(SelectionEvent event) {
-		        ((FormData) sash.getLayoutData()).left = new FormAttachment(0, event.x);
-		        sash.getParent().layout();
-		      }
-		    });
+			public void widgetSelected(SelectionEvent event) {
+				((FormData) sash.getLayoutData()).left = new FormAttachment(0, event.x);
+				sash.getParent().layout();
+			}
+		});
 		viewer = new TableViewer(displayArea, SWT.MULTI | SWT.FULL_SELECTION | SWT.BORDER | SWT.VIRTUAL);
 		viewer.getTable().addKeyListener(new TableKeyListener(viewer));
 		//viewer.setLabelProvider(new LineLabelProvider(this));
@@ -565,10 +486,11 @@
 		viewer.getTable().setLinesVisible(true);
 		viewer.getTable().setHeaderVisible(true);
 
-		if (corpus != null && corpus.getFont() != null && corpus.getFont().length() > 0) {
+		String f = concordance.getCorpus().getFont();
+		if (f != null && f.length() > 0) {
 			Font old = viewer.getTable().getFont();
 			FontData fD = old.getFontData()[0];
-			Font font = new Font(Display.getCurrent(), corpus.getFont(), fD.getHeight(), fD.getStyle()); 
+			Font font = new Font(Display.getCurrent(), f, fD.getHeight(), fD.getStyle()); 
 			viewer.getTable().setFont(font);
 			viewer2.getTable().setFont(font);
 		}
@@ -587,7 +509,7 @@
 				bar.setSelection(Math.round(x*(M-T)/(l+k+r-t)));//this is how x translate in terms of bar selection
 			}
 		};
-		
+
 		// try to center on keyword column
 		viewer.getTable().addListener(SWT.Resize, tableResizeListener);
 
@@ -604,9 +526,9 @@
 		viewer.getTable().addKeyListener(kldelete);
 		viewer2.getTable().addKeyListener(kldelete);
 
-//		firstColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
-//		firstColumn.setWidth(0);
-//		firstColumn.setResizable(false);
+		//		firstColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
+		//		firstColumn.setWidth(0);
+		//		firstColumn.setResizable(false);
 
 		TableViewerColumn leftColumnViewer = new TableViewerColumn(viewer, SWT.RIGHT);
 		leftContextColumn = leftColumnViewer.getColumn();
@@ -633,7 +555,7 @@
 					comparator = new ReverseComparator(comparator);
 				} else
 					viewer.getTable().setSortDirection(SWT.UP);
-				comparator.initialize(corpus);
+				comparator.initialize(concordance.getCorpus());
 				currentComparator = comparator;
 				complexsorter.setKey(2);//set ref key
 				sort();
@@ -670,7 +592,7 @@
 					comparator = new ReverseComparator(comparator);
 				} else
 					viewer.getTable().setSortDirection(SWT.UP);
-				comparator.initialize(corpus);
+				comparator.initialize(concordance.getCorpus());
 				currentComparator = comparator;
 				complexsorter.setKey(1);//set ref key
 				sort();
@@ -682,7 +604,7 @@
 			}
 		});
 
-		
+
 		TableViewerColumn rightContextColumnViewer = new TableViewerColumn(viewer, SWT.LEFT);
 		rightContextColumn = rightContextColumnViewer.getColumn();
 		rightContextColumn.setText(Messages.ConcordancesEditor_4);
@@ -709,7 +631,7 @@
 				} else {
 					viewer.getTable().setSortDirection(SWT.UP);
 				}
-				comparator.initialize(corpus);
+				comparator.initialize(concordance.getCorpus());
 				currentComparator = comparator;
 				complexsorter.setKey(3); //set ref key
 				sort();
@@ -721,33 +643,33 @@
 			}
 		});
 
-//		firstColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
-//		firstColumn.setWidth(0);
-//		firstColumn.setResizable(false);
-		
+		//		firstColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
+		//		firstColumn.setWidth(0);
+		//		firstColumn.setResizable(false);
+
 		leftContextColumn.setWidth(200);
 		keywordColumn.setWidth(100);
 		rightContextColumn.setWidth(200);
-		
+
 		//resetColumnWidths(); // set column widths
 
 		createContextMenu();
 
-//		// And now, a sweet piece of code :)
-//		// When the window is resized, the scrollbar is adjusted so that the
-//		// keywords remain centered
-//		viewer.getTable().addListener(SWT.Resize, new Listener() {
-//			@Override
-//			public void handleEvent(Event event) {
-//				ScrollBar bar = viewer.getTable().getHorizontalBar();
-//				//float l = leftContextColumn.getWidth();
-//				//float k = keywordColumn.getWidth();
-//				rightContextColumn.getWidth();
-//				//float t = lineTableViewer.getTable().getClientArea().width;
-//				bar.getMaximum();
-//				bar.getThumb();
-//			}
-//		});
+		//		// And now, a sweet piece of code :)
+		//		// When the window is resized, the scrollbar is adjusted so that the
+		//		// keywords remain centered
+		//		viewer.getTable().addListener(SWT.Resize, new Listener() {
+		//			@Override
+		//			public void handleEvent(Event event) {
+		//				ScrollBar bar = viewer.getTable().getHorizontalBar();
+		//				//float l = leftContextColumn.getWidth();
+		//				//float k = keywordColumn.getWidth();
+		//				rightContextColumn.getWidth();
+		//				//float t = lineTableViewer.getTable().getClientArea().width;
+		//				bar.getMaximum();
+		//				bar.getThumb();
+		//			}
+		//		});
 
 		// back to text mouse listener
 		MouseListener ms = new MouseListener() {
@@ -765,7 +687,7 @@
 		};
 		viewer.getTable().addMouseListener(ms);
 		viewer2.getTable().addMouseListener(ms);
-		
+
 		// On Windows, the selection is gray if the table does not have focus.
 		// To make both tables appear in focus, draw the selection background
 		// here.
@@ -794,7 +716,7 @@
 		rightContextColumn.addControlListener(new ConcordanceColumnSizeControlListener(rightContextColumn));
 
 		viewer.getTable().addListener(SWT.EraseItem, eraseListener);
-		
+
 		leftTable = viewer2.getTable();
 		rightTable = viewer.getTable();
 		viewer2.getTable().addSelectionListener(new SelectionListener() {
@@ -830,24 +752,24 @@
 
 		// set Layout datas
 		FormData data = new FormData();
-	    data.top = new FormAttachment(0); 
-	    data.bottom = new FormAttachment(100); 
-	    data.left = new FormAttachment(0);
-	    data.right = new FormAttachment(sash,0);
-	    viewer2.getTable().setLayoutData(data);
-	    
+		data.top = new FormAttachment(0); 
+		data.bottom = new FormAttachment(100); 
+		data.left = new FormAttachment(0);
+		data.right = new FormAttachment(sash,0);
+		viewer2.getTable().setLayoutData(data);
+
 		FormData data2 = new FormData();
-	    data2.top = new FormAttachment(0, 0); 
-	    data2.bottom = new FormAttachment(100, 0); 
-	    data2.left = new FormAttachment(10);
-	    sash.setLayoutData(data2);
-		
+		data2.top = new FormAttachment(0, 0); 
+		data2.bottom = new FormAttachment(100, 0); 
+		data2.left = new FormAttachment(10);
+		sash.setLayoutData(data2);
+
 		FormData data3 = new FormData();
-	    data3.top = new FormAttachment(0); 
-	    data3.bottom = new FormAttachment(100); 
-	    data3.left = new FormAttachment(sash,0);
-	    data3.right = new FormAttachment(100);
-	    viewer.getTable().setLayoutData(data3);
+		data3.top = new FormAttachment(0); 
+		data3.bottom = new FormAttachment(100); 
+		data3.left = new FormAttachment(sash,0);
+		data3.right = new FormAttachment(100);
+		viewer.getTable().setLayoutData(data3);
 	}
 
 	/**
@@ -857,9 +779,7 @@
 		if (concordance != null && currentComparator != null) {
 
 			//System.out.println("concordance sort props: "+concordance.getLeftCAnalysisProperty()+", "+concordance.getKeywordAnalysisProperty()+", "+concordance.getRightCAnalysisProperty());
-			concordance.setLeftAnalysisProperties(selectedLeftSortProperties);
-			concordance.setKeywordAnalysisProperties(selectedKeywordSortProperties);
-			concordance.setRightAnalysisProperties(selectedRightSortProperties);
+			concordance.resetLines();
 
 			try {
 				Log.info(NLS.bind(CooccurrenceUIMessages.CooccurrencesEditor_0, currentComparator.getName()));
@@ -874,12 +794,13 @@
 							monitor.beginTask(Messages.ConcordancesEditor_6, concordance.getNLines());
 							concordance.setCurrentMonitor(this);
 							concordance.sort(currentComparator);
+							concordance.setTopIndex(0);
 							concordance.setCurrentMonitor(null);
 							syncExec(new Runnable() {
 								@Override
 								public void run() {
 									StatusLine.setMessage(RCPMessages.SORT_DONE);
-									fillDisplayArea(topLine, topLine + nLinePerPage - 1);
+									fillDisplayArea();
 								}
 							});
 
@@ -913,15 +834,19 @@
 	 * @param from the from
 	 * @param to the to
 	 */
-	public void fillDisplayArea(int from, int to) {
+	public void fillDisplayArea() {
 		if (viewer == null)
 			return;
 
-		viewer.getControl().setRedraw(false);
-		viewer2.getControl().setRedraw(false);
-
+		int from = concordance.getTopIndex();
 		from = Math.max(from, 0);
+		
+		int to = from + concordance.getNLinePerPage() - 1;
 		to = Math.min(to, concordance.getNLines() - 1);
+		
+		viewer.getControl().setRedraw(false);
+		viewer2.getControl().setRedraw(false);
+		
 		List<Line> lines = null;
 		if (concordance.getNLines() > 0) {
 			try {
@@ -936,21 +861,17 @@
 		viewer.setInput(lines);
 		viewer2.setInput(lines);
 
-		topLine = from;
-		bottomLine = to;
-
 		navigationWidget.setInfoLineText(""+(from + 1), //$NON-NLS-1$
 				" - "+(to + 1) + " / " + concordance.getNLines()); //$NON-NLS-1$ //$NON-NLS-2$
 
-		navigationWidget.setPreviousEnabled(topLine > 0);
-		navigationWidget.setFirstEnabled(topLine > 0);
-		navigationWidget.setNextEnabled(bottomLine < concordance.getNLines() - 1);
-		navigationWidget.setLastEnabled(bottomLine < concordance.getNLines() - 1);
+		navigationWidget.setPreviousEnabled(concordance.getTopIndex() > 0);
+		navigationWidget.setFirstEnabled(concordance.getTopIndex() > 0);
+		navigationWidget.setNextEnabled((concordance.getTopIndex()+concordance.getNLinePerPage()) < concordance.getNLines() - 1);
+		navigationWidget.setLastEnabled((concordance.getTopIndex()+concordance.getNLinePerPage()) < concordance.getNLines() - 1);
 		navigationWidget.layout();
 		navigationWidget.getParent().layout();
 
 		refreshReferenceColumnTitle();
-
 		viewer.getControl().setRedraw(true);
 		viewer2.getControl().setRedraw(true);
 	}
@@ -978,7 +899,7 @@
 	public Composite getQueryArea() {
 		return queryArea;
 	}
-	
+
 	/**
 	 * Get the Composite that contains the navigation buttons
 	 * 
@@ -989,7 +910,7 @@
 	public Composite getNavigationArea() {
 		return queryArea;
 	}
-	
+
 	/**
 	 * Compose control area.
 	 *
@@ -1029,14 +950,16 @@
 
 		// [ (v)]
 		// queryWidget = new QueryWidget(queryArea, SWT.DROP_DOWN);
-		queryWidget = new AssistedQueryWidget(queryArea, SWT.DROP_DOWN, corpus);
+		queryWidget = new AssistedQueryWidget(queryArea, SWT.DROP_DOWN, concordance.getCorpus());
 		queryWidget.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
 		queryWidget.addKeyListener(new KeyListener() {
 			@Override
 			public void keyPressed(KeyEvent e) {
 				// System.out.println("key pressed : "+e.keyCode);
 				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
-					compute();
+					Query query = new Query(queryWidget.getQueryString());
+					concordance.setQuery(query);
+					compute(true);
 				}
 			}
 
@@ -1070,8 +993,8 @@
 			public void widgetSelected(SelectionEvent e) {
 				StatusLine.setMessage(Messages.ConcordancesEditor_55);
 				new ViewPropertySelectionDialog(getSite(),
-						availableKeywordViewProperties,
-						selectedKeywordViewProperties).open();
+						concordance.getAvailableKeywordViewProperties(),
+						concordance.getKeywordViewProperties()).open();
 				if (concordance != null)
 					try {
 						refreshViewProperties();
@@ -1102,7 +1025,9 @@
 		go.addSelectionListener(new SelectionListener() {
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				compute();
+				Query query = new Query(queryWidget.getQueryString());
+				concordance.setQuery(query);
+				compute(true);
 			}
 
 			@Override
@@ -1145,7 +1070,8 @@
 
 			@Override
 			public void widgetSelected(SelectionEvent arg0) {
-				fillDisplayArea(0, nLinePerPage - 1);
+				concordance.setTopIndex(0);
+				fillDisplayArea();
 			}
 		});
 
@@ -1157,11 +1083,11 @@
 
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				int top = topLine - nLinePerPage;
+				int top = concordance.getTopIndex() - concordance.getNLinePerPage();
 				if (top < 0)
 					top = 0;
-				int bottom = top + nLinePerPage -1 ;
-				fillDisplayArea(top, bottom);
+				concordance.setTopIndex(top);
+				fillDisplayArea();
 			}
 		});
 
@@ -1173,7 +1099,8 @@
 
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				fillDisplayArea(bottomLine + 1, bottomLine + nLinePerPage);
+				concordance.setTopIndex(concordance.getTopIndex() + concordance.getNLinePerPage());
+				fillDisplayArea();
 			}
 		});
 
@@ -1185,10 +1112,10 @@
 
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				int top = (concordance.getNLines()/nLinePerPage)*nLinePerPage;
-				int bottom = top + nLinePerPage -1 ;
-				fillDisplayArea(top, bottom);
-				//fillDisplayArea(concordance.getNLines() - 1 - nLinePerPage,concordance.getNLines() - 1);
+				int top = (concordance.getNLines()/concordance.getNLinePerPage())*concordance.getNLinePerPage();
+				int bottom = top + concordance.getNLinePerPage() -1;
+				concordance.setTopIndex(top);
+				fillDisplayArea();
 			}
 		});
 		hideBtn = new Button(navigationArea, SWT.PUSH);
@@ -1241,68 +1168,26 @@
 		//		}
 
 		queryArea.layout();
-		
 
+
 	}
 
 	/**
-	 * Computes the concordance and fills the display area with the specified lines range.
+	 * refresh
 	 * @param top
 	 * @param bottom
 	 */
-	public void compute(int top, int bottom, boolean fillDisplay) {
+	public void refresh(boolean update) {
 		StatusLine.setMessage(Messages.ConcordancesEditor_56);
-		Query query = new Query(queryWidget.getQueryString());
-
-		String cql_limit = null;
-		if (cqlSeparator != null) cql_limit = cqlSeparator.getText();
-		if (cql_limit != null && cql_limit.trim().length() == 0) cql_limit = null;
-		if (cql_limit == null) cql_limit = corpus.getCQLLimitQuery();
-
+		
 		//if (true)// concordance==null || concordance.getQuery()!=query)
 		try {
-			JobsTimer.start();
-			//Concordance oldConcordance = concordance;
-			System.out.println(NLS.bind(Messages.ConcordancesEditor_5, query.getQueryString(), corpus.getName()));
-			//concordance = new Concordance(corpus);
-			concordance.setParameters(query,
-					selectedLeftSortProperties, 
-					selectedRightSortProperties,
-					selectedKeywordSortProperties,
-					selectedLeftViewProperties,
-					selectedRightViewProperties,
-					selectedKeywordViewProperties,
-					getViewReferencePattern(),
-					getSortReferencePattern(),
-					leftContextSize, rightContextSize);
-			concordance.setCQLSeparator(cql_limit);
-
-			concordance.compute(false, null);
-
-			StatusLine.setMessage(NLS.bind(Messages.ConcordancesEditor_19, concordance.getNLines()));
-			if (concordance.getNLines() == 1)
-				System.out.println(RCPMessages.ONE_RESULT);
-			else if (concordance.getNLines() > 0)
-				System.out.println(NLS.bind(Messages.ConcordancesEditor_19, concordance.getNLines()));
-			else
-				System.out.println(TXMCoreMessages.COMPUTE_DONE_NO_RESULT);
-
-
-
-//			if (oldConcordance != null) {
-//				corpus.removeResult(oldConcordance);
-//				oldConcordance.clean(); // drop the CQP corpus
-//			}
-			//corpus.addResult(concordance);
-
 			CorporaView.refresh();
-			CorporaView.expand(corpus);
+			CorporaView.expand(concordance.getCorpus());
 			QueriesView.refresh();
 
-			if (fillDisplay) {
-				fillDisplayArea(top, bottom);
-			}
-
+			fillDisplayArea();
+				
 			setPartName(concordance.getName());
 			queryWidget.memorize();
 
@@ -1311,7 +1196,7 @@
 			JobsTimer.stopAndPrint();
 
 		} catch (Exception e1) {
-			System.err.println(RCPMessages.CorporaView_3+" "+Log.toString(e1)); //$NON-NLS-1$
+			System.out.println(RCPMessages.CorporaView_3+" "+Log.toString(e1)); //$NON-NLS-1$
 			//System.err.println(Messages.CorporaView_3);
 			org.txm.rcp.utils.Logger.printStackTrace(e1);
 			try {
@@ -1326,27 +1211,12 @@
 	}
 
 	/**
-	 * Computes the concordance and fills the display area with lines range corresponding to the first page.
-	 */
-	public void compute() {
-		this.compute(true);
-	}
-
-	/**
-	 * Computes the concordance and fills the display area with lines range corresponding to the first page.
-	 * @param fillDisplay
-	 */
-	public void compute(boolean fillDisplay) {
-		this.compute(0, nLinePerPage - 1, fillDisplay);
-	}
-
-	/**
 	 * Sets the line per page.
 	 *
 	 * @param nb the new line per page
 	 */
 	public void setLinePerPage(int nb) {
-		this.nLinePerPage = nb;
+		concordance.setNLinePerPage(nb);
 	}
 
 	/**
@@ -1355,20 +1225,15 @@
 	 * @return the line per page
 	 */
 	public int getLinePerPage() {
-		return nLinePerPage;
+		return concordance.getNLinePerPage();
 	}
 
 	/**
 	 * Update view properties label.
 	 */
 	void updateViewPropertiesLabel() {
-		StringBuffer buffer = new StringBuffer();
-		Iterator<Property> it = selectedKeywordViewProperties.iterator();
-		if (it.hasNext())
-			buffer.append(it.next().getName());
-		while (it.hasNext())
-			buffer.append("_" + it.next().getName()); //$NON-NLS-1$
-		viewPropertiesLabel.setText(buffer.toString());
+		String str = StringUtils.join(concordance.getKeywordViewProperties(), "_");
+		viewPropertiesLabel.setText(str);
 		viewPropertiesLabel.getParent().layout();
 		viewPropertiesLabel.update();
 		queryArea.layout();
@@ -1379,25 +1244,7 @@
 	 */
 	@Override
 	public String getTitleToolTip() {
-		if (concordance != null) {
-			StringBuffer buf = new StringBuffer();
-			buf.append("Concordance:\n"); //$NON-NLS-1$
-			buf.append("\tCorpus: " + corpus.getName() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			buf
-			.append("\tQuery: " + concordance.getQuery().getQueryString() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			buf
-			.append("\tView properties: " + viewPropertiesLabel.getText() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			buf
-			.append("\tLeft Context Sort property: " + selectedLeftSortProperties + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			buf
-			.append("\tKeyword Sort property: " + selectedKeywordSortProperties + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			buf
-			.append("\right Context Sort property: " + selectedRightSortProperties + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			buf.append("\tReference View Pattern: " + refViewPattern + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			buf.append("\tReference Sort Pattern: " + refSortPattern + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			return buf.toString();
-		}
-		return ""; //$NON-NLS-1$
+		return concordance.getDetails();
 	}
 
 	/**
@@ -1406,7 +1253,7 @@
 	 * @return the reference pattern
 	 */
 	ReferencePattern getViewReferencePattern() {
-		return refViewPattern;
+		return concordance.getRefViewPattern();
 	}
 
 	/**
@@ -1415,7 +1262,7 @@
 	 * @return the reference pattern
 	 */
 	ReferencePattern getSortReferencePattern() {
-		return refSortPattern;
+		return concordance.getRefAnalysePattern();
 	}
 
 	/**
@@ -1424,7 +1271,7 @@
 	 * @param list the new left sort properties
 	 */
 	public void setLeftSortProperties(List<Property> list) {
-		this.selectedLeftSortProperties = list;
+		concordance.setLeftAnalysisProperties(list);
 	}
 
 	/**
@@ -1433,16 +1280,8 @@
 	 * @param list the new keyword sort property
 	 */
 	public void setKeywordSortProperties(List<Property> list) {
-		this.selectedKeywordSortProperties = list;
-		if (concordance != null) {
-			try {
-				concordance.setAnalysisProperty(list);
-			} catch (Exception e) {
-				System.err.println(NLS.bind(
-						Messages.ERROR_WHILE_LOADING_CONCORDANCE_LINE, e));
-			}
-			sort();
-		}
+		concordance.setAnalysisProperty(list);
+		sort();
 	}
 
 	/**
@@ -1451,16 +1290,8 @@
 	 * @param list the new right sort properties
 	 */
 	public void setRightSortProperties(List<Property> list) {
-		this.selectedRightSortProperties = list;
-		if (concordance != null) {
-			try {
-				concordance.setAnalysisProperty(list);
-			} catch (Exception e) {
-				System.err.println(NLS.bind(
-						Messages.ERROR_WHILE_LOADING_CONCORDANCE_LINE, e));
-			}
-			sort();
-		}
+		concordance.setAnalysisProperty(list);
+		sort();
 	}
 
 	/**
@@ -1469,19 +1300,9 @@
 	 * @param referencePattern the new reference pattern
 	 */
 	public void setRefViewPattern(ReferencePattern referencePattern) {
-		this.refViewPattern = referencePattern;
-
-		if (concordance != null) {
-			concordance.setRefViewPattern(referencePattern);
-			//			int top = topLine;
-			//			int bottom = bottomLine;
-			//
-			sort();
-			//fillDisplayArea(top, bottom); // we return to the previously
-
-			// displayed page
-			this.resetLeftTableColumnWidths();
-		}
+		concordance.setRefViewPattern(referencePattern);
+		sort();
+		this.resetLeftTableColumnWidths();
 	}
 
 	/**
@@ -1490,16 +1311,8 @@
 	 * @param referencePattern the new reference pattern
 	 */
 	public void setRefSortPattern(ReferencePattern referencePattern) {
-		this.refSortPattern = referencePattern;
-
-		if (concordance != null) {
-			concordance.setRefAnalysePattern(referencePattern);
-			//			int top = topLine;
-			//			int bottom = bottomLine;
-			sort();
-			//fillDisplayArea(top, bottom); // we return to the previously
-			// displayed page
-		}
+		concordance.setRefAnalysePattern(referencePattern);
+		sort();
 	}
 
 	/**
@@ -1509,18 +1322,10 @@
 	 * @param rightContextSize the right context size
 	 */
 	public void setContextSize(int leftContextSize, int rightContextSize) {
-		this.leftContextSize = leftContextSize;
-		this.rightContextSize = rightContextSize;
-		if (concordance != null) {
-			concordance.setLeftContextSize(leftContextSize);
-			concordance.setRightContextSize(rightContextSize);
-			int top = topLine;
-			int bottom = bottomLine;
-			//sort();
-			fillDisplayArea(top, bottom); // we return to the previously
-			resetRightTableColumnWidths();
-			// displayed page
-		}
+		concordance.setLeftContextSize(leftContextSize);
+		concordance.setRightContextSize(rightContextSize);
+		fillDisplayArea(); // we return to the previously
+		resetRightTableColumnWidths();
 	}
 
 	/**
@@ -1543,7 +1348,7 @@
 				//				System.out.println("Col: "+getPointedColumn());
 			}
 		});
-		
+
 		MenuManager menuManager = new MenuManager(); //$NON-NLS-1$
 		Menu menu = menuManager.createContextMenu(viewer.getTable());
 		menuManager.setRemoveAllWhenShown(true);
@@ -1561,7 +1366,7 @@
 			}
 		});
 		viewer.getTable().setMenu(menu);
-		
+
 		MenuManager menuManagerLeft = new MenuManager(); //$NON-NLS-1$
 		Menu menuLeft = menuManagerLeft.createContextMenu(viewer2.getTable());
 		menuManagerLeft.setRemoveAllWhenShown(true);
@@ -1575,7 +1380,7 @@
 			}
 		});
 		viewer2.getTable().setMenu(menuLeft);
-		
+
 		//viewer.getTable().setMenu(menuManager.createContextMenu(viewer.getTable()));
 		//register the right menu to the editor site
 		getSite().registerContextMenu(menuManager, viewer);
